<template>
    <div class="box-table--body animated fadeInUp">
        <div class="box-body--left">
            <p class="text-id">{{ plan.name }}</p>
            <p class="text-idBlue">{{ amount }}</p>
            <p class="text-id"><span>% {{ percent }}</span> - {{ $t('plans.percent_type.' + plan.type) }}</p>
            <p class="text-idBlue">{{ plan.duration }} {{ $t('plans.duration_type.' + plan.type) }}</p>
        </div>
        <div class="box-body--right">
            <svg class="look" :class="hiddenClass" @click="toggleHidden">
                <use xlink:href="/img/sprite.svg#private"/>
            </svg>
            <router-link :to="route('plans_edit', {id: plan.id})">
                <svg class="edit">
                    <use xlink:href="/img/sprite.svg#edit"/>
                </svg>
            </router-link>
            <svg class="delete" @click.prevent="deletePlan">
                <use xlink:href="/img/sprite.svg#cancel-button"/>
            </svg>
        </div>
    </div>
</template>

<script>
    import {mapGetters} from 'vuex';
    import route from "../../mixins/route";
    import currencies from "../../currencies";

    export default {
		name: "Plan",
        props: ['plan'],
        mixins: [route],
        computed: {
			...mapGetters([
				'axios',
				'csrf'
			]),
			currency(){
				return currencies.getById(this.plan.currency_id);
            },
            amount(){
                return currencies.formatWithDefault(this.plan.min_amount, this.plan.currency) + ' - ' + currencies.formatWithDefault(this.plan.max_amount, this.plan.currency)
            },
            percent(){
				return Number.parseFloat(this.plan.percent).toFixed(2);
            },
			hiddenClass(){
				return this.plan.is_hidden ? 'is-hidden' : ''
			},
        },
        methods: {
            deletePlan(){
				this.$emit('delete', this.plan.id);
            },
			toggleHidden(){
				this.axios
					.post(`plans/${this.plan.id}/visible`)
					.then(({ data }) => {
						console.log(data);
						if(data.status === 'success'){
							console.log(data.message);
							this.$swal(data.message);
							this.$emit('updated', data.plan);
						}else{
							this.$swal('Неизвестная ошибка');
						}
					})
			}
        }
	}
</script>

<style scoped lang="scss">
.box-body--right .look.is-hidden {
	fill: #2b5ede;

	&:hover {
		fill: #c6c6c6;
	}
}
</style>
